diff --git a/arch/riscv/Kconfig b/arch/riscv/Kconfig
index 24b1b6abf0a7..5d770b8e2756 100644
--- a/arch/riscv/Kconfig
+++ b/arch/riscv/Kconfig
@@ -288,6 +288,10 @@ config VDSO64
 	bool
 	depends on MMU
 
+config VDSO64ILP32
+	bool
+	depends on MMU
+
 source "arch/riscv/Kconfig.socs"
 source "arch/riscv/Kconfig.errata"
 
@@ -707,6 +711,7 @@ config COMPAT
 	bool "Kernel support for 32-bit U-mode"
 	default 64BIT
 	select VDSO32
+	select VDSO64ILP32 if $(cc-option,-march=rv64g -mabi=ilp32)
 	depends on 64BIT && MMU
 	help
 	  This option enables support for a 32-bit U-mode running under a 64-bit
diff --git a/arch/riscv/Makefile b/arch/riscv/Makefile
index 3b7d5ebf3c78..8605050bddd0 100644
--- a/arch/riscv/Makefile
+++ b/arch/riscv/Makefile
@@ -140,6 +140,8 @@ vdso_install:
 		$(build)=arch/riscv/kernel/vdso vdso32_install
 	$(if $(CONFIG_VDSO64),$(Q)$(MAKE) \
 		$(build)=arch/riscv/kernel/vdso vdso64_install
+	$(if $(CONFIG_VDSO64ILP32),$(Q)$(MAKE) \
+		$(build)=arch/riscv/kernel/vdso vdso64ilp32_install
 
 ifeq ($(KBUILD_EXTMOD),)
 ifeq ($(CONFIG_MMU),y)
@@ -149,6 +151,8 @@ vdso_prepare: prepare0
 		$(build)=arch/riscv/kernel/vdso include/generated/vdso32-offsets.h)
 	$(if $(CONFIG_VDSO64),$(Q)$(MAKE) \
 		$(build)=arch/riscv/kernel/vdso include/generated/vdso64-offsets.h)
+	$(if $(CONFIG_VDSO64ILP32),$(Q)$(MAKE) \
+		$(build)=arch/riscv/kernel/vdso include/generated/vdso64ilp32-offsets.h)
 endif
 endif
 
diff --git a/arch/riscv/kernel/Makefile b/arch/riscv/kernel/Makefile
index 23032ac7f51d..a4583a29b28b 100644
--- a/arch/riscv/kernel/Makefile
+++ b/arch/riscv/kernel/Makefile
@@ -59,6 +59,7 @@ obj-y	+= probes/
 obj-$(CONFIG_MMU) += vdso.o vdso/
 obj-$(CONFIG_VDSO64)  += vdso64.o
 obj-$(CONFIG_VDSO32)  += vdso32.o
+obj-$(CONFIG_VDSO64ILP32)  += vdso64ilp32.o
 
 obj-$(CONFIG_RISCV_M_MODE)	+= traps_misaligned.o
 obj-$(CONFIG_FPU)		+= fpu.o
diff --git a/arch/riscv/kernel/vdso/Makefile b/arch/riscv/kernel/vdso/Makefile
index df8f68bb0937..629989b1ad05 100644
--- a/arch/riscv/kernel/vdso/Makefile
+++ b/arch/riscv/kernel/vdso/Makefile
@@ -148,3 +148,62 @@ vdso32.so: $(obj)/vdso32.so.dbg
 
 vdso32_install: vdso32.so
 endif
+
+ifdef CONFIG_VDSO64ILP32
+VDSO64ILP32_CC_FLAGS := -march=rv64g -mabi=ilp32
+VDSO64ILP32_LD_FLAGS := -melf32lriscv
+
+obj-as-vdso64ilp32  = $(patsubst %, %-64ilp32.o, $(vdso-as-syms)) note-64ilp32.o
+obj-as-vdso64ilp32 := $(addprefix $(obj)/, $(obj-as-vdso64ilp32))
+
+obj-cc-vdso64ilp32  = $(patsubst %, %-64ilp32.o, $(vdso-cc-syms))
+obj-cc-vdso64ilp32 := $(addprefix $(obj)/, $(obj-cc-vdso64ilp32))
+
+targets += $(obj-as-vdso64ilp32) $(obj-cc-vdso64ilp32) vdso64ilp32.so vdso64ilp32.so.dbg vdso64ilp32.lds
+
+$(obj)/vdso64ilp32.so.dbg: $(obj)/vdso.lds $(obj-as-vdso64ilp32) $(obj-cc-vdso64ilp32) FORCE
+	$(call if_changed,vdso64ilp32ld)
+LDFLAGS_vdso64ilp32.so.dbg = -shared -S -soname=linux-vdso64ilp32.so.1 \
+	--build-id=sha1 --hash-style=both --eh-frame-hdr
+
+# The DSO images are built using a special linker script
+# Make sure only to export the intended __vdso_xxx symbol offsets.
+quiet_cmd_vdso64ilp32ld = VDSO64ILP32LD  $@
+      cmd_vdso64ilp32ld = $(VDSO_LD) $(ld_flags) $(VDSO64ILP32_LD_FLAGS) -T $(filter-out FORCE,$^) -o $@.tmp && \
+                   $(OBJCOPY) $(patsubst %, -G __vdso_%, $(vdso-as-syms) $(vdso-cc-syms)) $@.tmp $@ && \
+                   rm $@.tmp
+
+# actual build commands
+quiet_cmd_vdso64ilp32as = VDSO64ILP32AS $@
+      cmd_vdso64ilp32as = $(VDSO_CC) $(a_flags) $(VDSO64ILP32_CC_FLAGS) -c -o $@ $<
+quiet_cmd_vdso64ilp32cc = VDSO64ILP32CC $@
+      cmd_vdso64ilp32cc = $(VDSO_CC) $(c_flags) $(VDSO64ILP32_CC_FLAGS) -c -o $@ $<
+
+# Force dependency
+$(obj)/vdso64ilp32.o: $(obj)/vdso64ilp32.so
+
+$(obj-as-vdso64ilp32): %-64ilp32.o: %.S FORCE
+	$(call if_changed_dep,vdso64ilp32as)
+$(obj-cc-vdso64ilp32): %-64ilp32.o: %.c FORCE
+	$(call if_changed_dep,vdso64ilp32cc)
+
+CFLAGS_hwprobe-64ilp32.o += -fPIC
+
+CFLAGS_vgettimeofday-64ilp32.o += -fPIC -include $(c-gettimeofday-y)
+# Disable -pg to prevent insert call site
+CFLAGS_REMOVE_vgettimeofday-64ilp32.o = $(CC_FLAGS_FTRACE)
+
+# Generate VDSO offsets using helper script
+gen-vdso64ilp32sym := $(srctree)/$(src)/gen_vdso64ilp32_offsets.sh
+quiet_cmd_vdso64ilp32sym = VDSO64ILP32SYM $@
+	cmd_vdso64ilp32sym = $(NM) $< | $(gen-vdso64ilp32sym) | LC_ALL=C sort > $@
+
+include/generated/vdso64ilp32-offsets.h: $(obj)/vdso64ilp32.so.dbg $(obj)/vdso64ilp32.so FORCE
+	$(call if_changed,vdso64ilp32sym)
+
+vdso64ilp32.so: $(obj)/vdso64ilp32.so.dbg
+	@mkdir -p $(MODLIB)/vdso
+	$(call cmd,vdso_install)
+
+vdso64ilp32_install: vdso64ilp32.so
+endif
diff --git a/arch/riscv/kernel/vdso/gen_vdso64ilp32_offsets.sh b/arch/riscv/kernel/vdso/gen_vdso64ilp32_offsets.sh
new file mode 100755
index 000000000000..6af2db7a26ad
--- /dev/null
+++ b/arch/riscv/kernel/vdso/gen_vdso64ilp32_offsets.sh
@@ -0,0 +1,5 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+
+LC_ALL=C
+sed -n -e 's/^[0]\+\(0[0-9a-fA-F]*\) . \(__vdso_[a-zA-Z0-9_]*\)$/\#define rv64ilp32\2_offset\t0x\1/p'
diff --git a/arch/riscv/kernel/vdso64ilp32.S b/arch/riscv/kernel/vdso64ilp32.S
new file mode 100644
index 000000000000..5b658da1eeef
--- /dev/null
+++ b/arch/riscv/kernel/vdso64ilp32.S
@@ -0,0 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-only */
+
+#define	vdso64_start	vdso64ilp32_start
+#define	vdso64_end	vdso64ilp32_end
+
+#define	__VDSO_PATH	"arch/riscv/kernel/vdso/vdso64ilp32.so"
+
+#include "vdso64.S"